/***
 * Copyright(C) 2005 NSP. All rights reserved.
 *
 * LQłȂƂ́C
 * L Chage #Chara {^ׂ̗̃{bNXɏŁC{^D
 * LI̓R{{bNXŃLID
 * -- New Chara -- IΐVLǉ邱ƂɂȂD
 * Base URL ̓Xbh̃x[X̃AhXŁC
 * Web 痎ƂĂXbhԍ Threads(Fetch) ̉ɋ󔒋؂ŏC
 * [JɕۑĂ̂gȂ Thesads(Local) ֏D
 * Ƃ Analyze ΁C݂̖Oe[uɊÂĉ͂D
 * ͂ɎgXbhԍ́CẼXg{bNXɗƂĎcC
 *   Threads(Fetch) ȂǂɃhbO邱Ƃňȍ~̓͂ȒPɂłD
 * ܂C_E[ĥ thre fBNgɕۑ(HTML)D
 *
 * ͌Cʉ Voted Name List ^uɓ[ꂽO
 * ΉL̃^uɕ\ĂD
 * Ê͓ŁCL^uEŕςāCD&D ŖOړłD
 * Oʂ芄UC Update Names {^D
 * ƍXVꂽe[uɊÂVʂoD
 * ܂łɊUꂽÓC̓[ɏoĂȂ̂܂߁C
 * Chara Name Tables ̊eL̃^uŊmFł
 *
 * Graph ^uɂ͓[̎Ԍo߂vbgD
 * ̃{bNX y ̍ől͂ DrawGraph {^ƁC
 * V y őlōĕ`悳D
 *
 * ͂ɎgꂽX Res List ^uɑSĂD
 *
 * AvP[VIɂ́CLƊel̖O̊Ue[uC
 * ɃXbhԍ̗ data fBNgɕۑD
 * ͎̋Nɓǂݍ܂D
 *
 * TODO
 * ToolTips ܂傤D
 * StatusBar ܂傤D
 */


using System;
using System.Net;
using System.IO;
using System.Text;
using System.Threading;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Drawing;
using System.Collections;
using System.Drawing.Drawing2D;




namespace SaimoeCounter {

	/**
	 * ȒPȃj[... v
	 */
	class SaimoeMenu : MainMenu {
		SaimoeCounter scounter;
		MenuItem helpMenu;
		MenuItem exitMenu;
		public SaimoeMenu(SaimoeCounter scounter){
			this.scounter = scounter;
			helpMenu = new MenuItem();
			helpMenu.Text = "Help";
			helpMenu.Click += new EventHandler(HelpMenu_Click);

			exitMenu = new MenuItem();
			exitMenu.Text = "Exit";
			exitMenu.Click += new EventHandler(ExitMenu_Click);
			this.MenuItems.Add(exitMenu);
			this.MenuItems.Add(helpMenu);
			
		}
		void ExitMenu_Click(object src, EventArgs e){
			scounter.Close();
			//scounter.Dispose();
			//Application.Exit();
		}
		void HelpMenu_Click(object src, EventArgs e){
			Console.WriteLine("LIŃXbhԍ󔒋؂ŏ Analyze {^D");
		}
	}

	
	/**
	 * Xe[^Xo[
	 * ԕ\ƃvOXo[\̈̊mۂ̂
	 */
	class SaimoeCounterStatusBar : StatusBar {
		const string STATUS_STRING_PRE = "Status: ";
		private StatusBarPanel date;
		private StatusBarPanel status;
		private StatusBarPanel progress;
		Thread timer;
		SaimoeCounter scounter;
		public SaimoeCounterStatusBar(SaimoeCounter scounter){
			this.scounter = scounter;
			createStatusBar();
		}
		void createStatusBar(){
			status = new StatusBarPanel();
			date = new StatusBarPanel();
			progress = new StatusBarPanel();
			this.Panels.Add(progress);
			this.Panels.Add(date);

			date.Width = 145;
			progress.Text = "ProgressBar";
			progress.AutoSize = StatusBarPanelAutoSize.Spring;
			progress.Style = StatusBarPanelStyle.OwnerDraw;
			date.BorderStyle = StatusBarPanelBorderStyle.Sunken;
			progress.BorderStyle = StatusBarPanelBorderStyle.Sunken;
			
			this.ShowPanels = true;
			timer = new Thread(new ThreadStart(run_timer));
			timer.Start();
		}
		public void StopTimer(){
			timer.Abort();
		}
		void run_timer(){
			for(;;){
				date.Text = "Now:  " + DateTime.Now.ToString();
				Thread.Sleep(200);
			}
		}
		public string StatusString {
			set { this.status.Text = STATUS_STRING_PRE + value; }
		}
	}
	/**
	 * Settnig Panel ɂĉɃ^uCAEg
	 */
	class SaimoeCounterLayout : Panel{
		Panel tabs;
		SaimoeCounter scounter;
		SettingPanel setting;
		Panel panel;
		public SaimoeCounterLayout(SaimoeCounter scounter, SettingPanel setting, Panel tabs){
			this.setting = setting;
			this.scounter = scounter;
			this.tabs = tabs;
			setting.Dock = DockStyle.Fill;
			panel = new Panel();
			panel.BorderStyle = BorderStyle.Fixed3D;
			panel.Controls.Add(setting);
			this.Controls.Add(panel);
			this.Controls.Add(tabs);
			this.Dock = DockStyle.Fill;
			this.SizeChanged += new EventHandler(SizeChanged_Hander);
			this.setting.CharaSelector.NumOfCharaChanged += new NumOfCharaHandler(SettingChanged_Handler);
			
		}
		void SettingChanged_Handler(int n) {
			SizeChanged_Hander(null, null);
		}
		void SizeChanged_Hander(object src, EventArgs e){
			Size sc = this.ClientSize;
			Size sp = panel.Size;
			Size scp = panel.ClientSize;
			int top = 5;
			int difH =  sp.Height - scp.Height;
			int h = setting.MinHeight;
			int hp = h + difH;
			int ht = sc.Height - hp - top;
			if(ht < 0) ht = 0;
			panel.Height = hp;
			panel.Width = sc.Width;
			tabs.Height = ht;
			tabs.Width = sc.Width;
			panel.Location = new Point(0,top);
			tabs.Location = new Point(0,hp+top);
		}
	}
	/***
	 * Ԃ̂
	 */
	public class SaimoeCounterStatus {
		public const int Init = 0;                  // 
		public const int RecordsAreExtracted = 1;   // R[ho
		public const int CurrentNamesGenerated = 2; // [o
		public const int CountsGenerated = 4;       // [𐔂
	}
	/***
	 * {
	 * gLꗗƂꂼ̖Oe[úC
	 * AvJnɓǂݍ܂CAvIɕۑD
	 * ƂĂXbh̃f[^ۑD
	 */
	public class SaimoeCounter : Form {
		// 
		int status;
		public int Status {
			get { return this.status; }
		}
		// LςƂɌĂ
		public event NumOfCharaHandler NumOfCharaChanged;
		// L̑IύX
		public event SelectCharaHandler SelectCharaChanged;
		const int CONTROL_HEIGHT = 28;         // {[_[̖k̂Ƃ̍
		private TabControl tabs;
		private NameListTab tabNameListNew;
		private GraphTab tabGraph;
		private ResListTab tabResList;
		private SaimoeCounterStatusBar statusBar;

		private SaimoeCounterLayout layout;
		private SettingPanel panelSetting; 
		private CharaNameListTabControl panelChNameList;
		private TabPage tabChNameList;

		private ReadHTMLEventHandler [] reporthanders;  // is󋵏p

		private SaimoeMenu menu;
		private Hashtable [] nameTables;       // LƂ̖Oꗗ
		private Hashtable currentNames;        // ݂̖OXg

		// ^u̖O
		const string CHARANAMELIST_TABNAME = " Chara Name Tables ";
		const string SETTING_TABNAME       = "   Setting   ";
		
		const string DATA_DIR = "data/";       // f[^fBNg
		const string THRE_DIR = "thre/";       // XfBNg
		const string CHARA_FILE = DATA_DIR + "chara.txt";
		const string HISTORY_FILE = DATA_DIR + "hist.txt";
		const string NAME_FILE_PREFIX = DATA_DIR + "names_";
		const string NAME_FILE_POSTFIX = ".txt";
		const string NEW_CHARA = "-- New Chara --";

		const int INIT_BUTTLE_CHARA_NUM = 2;  // ̃L

		int [] counts;              // [
		string [] charas;        // L̖O
		Hashtable charaIndices;     // LCfbNXւ̑Ή
		int numOfCharas;            // ݂̑L
		int numButtleChara;         // ݂̑ΐL
		const int INIT_CHARA_MAX = 100;// gpłőL̏l
		const int INIT_MAX_DIGITS = 5;   // [̍ő包(hƃ\[gp)

		string [] selectedCharas;   // IĂLێ
		
		// 𕶎ɂJ̃\[gƌhp
		public static string [] spaces;
		static SaimoeCounter(){               // X^eBbNϐ̏
			createSpaces(INIT_MAX_DIGITS);
		}
		public Hashtable [] getTables() {
			Hashtable [] tables = new Hashtable[numButtleChara+1];
			for(int i = 1; i < tables.Length; i++){
				if(selectedCharas[i]==null
				   || !charaIndices.Contains(selectedCharas[i])){
					tables[i] = null;
				} else {
					tables[i] = nameTables[(int)charaIndices[selectedCharas[i]]];
				}
			}
			tables[0] = null;
			return tables;
		}
		public DateTime Date {
			get {return panelSetting.Date;}
		}
		public int NumButtleChara {
			get { return this.numButtleChara; }
		}
		public string [] SelectedCharas {
			get { return this.selectedCharas; }
		}
		// RXgN^
		SaimoeCounter(){
			status = SaimoeCounterStatus.Init;
			this.Text = "Saimoe Counter ݂񁗂΂";
			this.Closed+=new EventHandler(ApplicationClosed_Handler);
			charas = new string[INIT_CHARA_MAX];
			numOfCharas = 0;
			nameTables = new Hashtable[INIT_CHARA_MAX];
			for(int i = 0; i < INIT_CHARA_MAX; i++){
				nameTables[i] = null;
				charas[i] = null;
			}
			charaIndices = new Hashtable();
			currentNames = new Hashtable();
			numButtleChara = INIT_BUTTLE_CHARA_NUM;
			counts = new int[numButtleChara+1];
			selectedCharas = new string[numButtleChara+1];
			for(int i = 0; i < counts.Length; i++){
				counts[i] = 0;
				selectedCharas[i] = null;
			}
			initialize();    // h̏
			readCharaFile(); // Lǂݍ
		}
		void setBattleCharaNum(int n){
			int old = numButtleChara;
			numButtleChara = n;
			counts = new int[numButtleChara+1];
			for(int i = 0; i < counts.Length; i++){
				counts[i] = 0;
			}
			selectedCharas = panelSetting.CharaSelector.getSelectedNames();
			if((status & SaimoeCounterStatus.RecordsAreExtracted)!=0){
				statusMark(SaimoeCounterStatus.RecordsAreExtracted);
			} else {
				status = SaimoeCounterStatus.Init;
			}
		}

		
		// 󔒂𐶐ő n 
		public static void createSpaces(int n){
			spaces = new string[n];
			string str = "";
			for(int i = n-1; i>=0; i--){
				spaces[i] = str;
				str = str + " ";
			}
		}
		// ݂̃LԍɑΉLԂ
		public string getCharaName(int i){
			if(i>0) {
				if(selectedCharas[i]==null
				   || !charaIndices.Contains(selectedCharas[i])){
					return "Chara " + i;
				} else {
					
					return charas[(int)charaIndices[selectedCharas[i]]];
				}
			}
			return "Unknown";
		}

		// Ƃɂ̓Lt@Cɕۑ
		void ApplicationClosed_Handler(object sender, EventArgs e){
			statusBar.StopTimer();
			saveCharaFile();
		}

		// len Le[u𑝂₷
		void extendCharaNum(int len){
			if(len <= 0) return;
			Hashtable [] nt = new Hashtable[charas.Length + len];
			string [] nn = new string[nt.Length];
			for(int i = 0; i < charas.Length; i++){
				nn[i] = charas[i];
				nt[i] = nameTables[i];
			}
			charas = nn;
			nameTables = nt;
			for(int i = charas.Length; i < nameTables.Length; i++){
				nameTables[i] = null;
				charas[i] = null;
			}
		}
		// t@CLo(Oƃe[u)
		void readCharaFile(){
			if(!Directory.Exists(DATA_DIR)){
				Directory.CreateDirectory(DATA_DIR);
			}
			if(!Directory.Exists(THRE_DIR)){
				Directory.CreateDirectory(THRE_DIR);
			}
			try {
				// Lꗗ
				StreamReader sr = new StreamReader(CHARA_FILE);
				ArrayList list = new ArrayList();
				for(;;){
					string str = sr.ReadLine();
					if(str==null) break;
					if(!str.Equals("")) list.Add(str);
				}
				sr.Close();
				if(charas.Length <= list.Count+numOfCharas){
					extendCharaNum(list.Count+numOfCharas);
				}
				for(int i = 0; i < list.Count; i++){
					charas[i] = (string)list[i];
				}
			} catch (FileNotFoundException fnfe){
				fnfe.ToString();
			}
			// LɑΉe[u쐬
			for(int i = 0; i < charas.Length; i++){
				AddNewChara(charas[i]);
				try {
					StreamReader sr = new StreamReader(NAME_FILE_PREFIX + charas[i] + NAME_FILE_POSTFIX);
					for(;;){
						string str = sr.ReadLine();
						if(str==null) break;
						nameTables[i][str] = 0;
					}
					sr.Close();
				} catch (FileNotFoundException fnfe){
					fnfe.ToString();
				}
				
			}
			try {
				StreamReader sr = new StreamReader(HISTORY_FILE);
				ArrayList list = new ArrayList();
				for(;;){
					string str = sr.ReadLine();
					if(str==null) break;
					if(!str.Equals("")) list.Add(str);
				}
				sr.Close();
				string [] hist = new string[list.Count];
				for(int i = 0; i < list.Count; i++){
					hist[i] = (string)list[i];
				}
				panelSetting.setHistory(hist);
			} catch (FileNotFoundException fnfe){
				fnfe.ToString();
			}
			EnterComboBoxItems();
		}
		void EnterComboBoxItems(){
			for(int i = 0; i < numOfCharas; i++){
				panelSetting.CharaSelector.AddCharaName(charas[i]);
			}
		}

		// Lƃe[u̕ۑ
		void saveCharaFile(){
			if(!Directory.Exists(DATA_DIR)){
				Directory.CreateDirectory(DATA_DIR);
			}
				// Lꗗ
			StreamWriter sw = new StreamWriter(CHARA_FILE);
			for(int i = 0; i < numOfCharas; i++){
				sw.WriteLine(charas[i]);
			}
			sw.Close();
			// e[u
			for(int i = 0; i < numOfCharas; i++){
				sw = new StreamWriter(NAME_FILE_PREFIX + charas[i] + NAME_FILE_POSTFIX);
				foreach ( DictionaryEntry d in nameTables[i] ) {
					sw.WriteLine(d.Key);
				}
				sw.Close();			
			}
			string [] hist = panelSetting.getHistory();
			sw = new StreamWriter(HISTORY_FILE);
			for(int i = 0; i < hist.Length; i++){
				sw.WriteLine(hist[i]);
			}
			sw.Close();
		}
		// [̃JEgAbv
		// [f[^ currentNames Abvf[gĂׂ
		public void MakeCounts(){
			for(int i = 0; i < counts.Length; i++){
				counts[i] = 0;
			}
			// \Ȃ΋A
			if(currentNames.Count==0) return;

// 			RecordValidator validator = new RecordValidator(this);
// 			Hashtable [] tables = validator.Tables;
			Hashtable [] tables = getTables();
			foreach(string name in currentNames.Keys){
				int chara = 0;
				for(int i = 1; i < tables.Length; i++){
					if(tables[i].Contains(name)) {
						chara = i;
						break;
					}
				}
				counts[chara]+=(int)currentNames[name];
			}
			statusMark(SaimoeCounterStatus.CountsGenerated);
		}

		// 낢zuƂ
		private void initialize() {
			//CX^X
			tabs = new TabControl(); 
			
			tabs.SuspendLayout();
			this.SuspendLayout();


			
			// Setting ͂߂ׂ
			panelSetting = new SettingPanel(this);
			panelSetting.CharaSelector.NumOfCharaChanged += new NumOfCharaHandler(NumOfChara_Handler);
			panelSetting.CharaSelector.NewCharaAdded += new NewCharaHandler(NewChara_Handler);
			panelSetting.CharaSelector.SelectCharaChanged += new SelectCharaHandler(SelectChara_Handler);

			menu = new SaimoeMenu(this);
			this.Menu = menu;
			
			tabResList = new ResListTab(this);
			tabGraph = new GraphTab(this);
			tabNameListNew = new NameListTab(this);
			
			panelChNameList = new CharaNameListTabControl(this, INIT_BUTTLE_CHARA_NUM);		
			panelChNameList.Dock = DockStyle.Fill;
			panelChNameList.BorderStyle = BorderStyle.Fixed3D;
			tabChNameList = new TabPage();
			tabChNameList.Text = CHARANAMELIST_TABNAME;
			tabChNameList.Controls.Add(panelChNameList);


			statusBar = new SaimoeCounterStatusBar(this);
			
			// Rei֒ǉ

			tabs.Controls.Add(tabNameListNew);
			tabs.Controls.Add(tabGraph);
			tabs.Controls.Add(tabChNameList);
			tabs.Controls.Add(tabResList);



			tabs.Dock = DockStyle.Fill;
			Panel tabsPanel = new Panel();
			
			tabsPanel.Controls.Add(tabs);
			//tabsPanel.Dock = DockStyle.Fill;
			tabsPanel.BorderStyle = BorderStyle.Fixed3D;

			
			layout = new SaimoeCounterLayout(this, panelSetting, tabsPanel);
			layout.Dock = DockStyle.Fill;
			this.Controls.Add(layout);
			this.Controls.Add(statusBar);

			tabs.ResumeLayout(false);
			this.ResumeLayout(false);
			// Ŝ̃TCYw
			this.Size = new Size(800,760);
			
			
		}
		// LύX̒ʒm
		void NumOfChara_Handler(int numOfChara) {
			setBattleCharaNum(numOfChara); // ̐ύXĂ
			//Console.WriteLine("num of Char: " + numOfChara);
			if(NumOfCharaChanged!=null) NumOfCharaChanged(numOfChara);//ʒm
		}
		// VL̒ʒm
		void NewChara_Handler(string newChara) {
			if(!AddNewChara(newChara)) return;   // o^łȂ΋A
			//ZN^ɉ
			panelSetting.CharaSelector.AddCharaName(newChara);
			//Console.WriteLine("new chara: " + newChara);
		}
		// num Ԗڂ̃{bNXL chara I
		void SelectChara_Handler(string chara, int num){
			if((status & SaimoeCounterStatus.RecordsAreExtracted)!=0){
				statusMark(SaimoeCounterStatus.RecordsAreExtracted);
			} else {
				status = SaimoeCounterStatus.Init;
			}
			selectedCharas[num] = chara; // ̑IςĂ
			//Console.WriteLine("chara selection: " + chara + ", num = " + num);
			if(SelectCharaChanged!=null) SelectCharaChanged(chara, num);//ʒm
		}
		// VO̒ǉ
		bool AddNewChara(string name){
			if(name==null || name.Equals("")) return false;
			if(charaIndices.Contains(name)) return false;
			// ̈悪ȂΊm
			if(numOfCharas >= charas.Length) extendCharaNum(charas.Length);
			// e[u֓o^
			charas[numOfCharas] = name;
			nameTables[numOfCharas] = new Hashtable();
			charaIndices[name] = numOfCharas;           // t
			numOfCharas++;
			return true;
		}
		// ̓{^ꂽƂɌĂ΂ׂ
		// Xbhŉ͂
		Thread thread = null;
		public void doAnalyze(){
			if(thread==null || !thread.IsAlive){
				// LZNgȂƕ͂
				for(int i = 1; i < selectedCharas.Length; i++){
					if(selectedCharas[i]==null
					   || !charaIndices.Contains(selectedCharas[i])){
						MessageBox.Show("Please select characters first.", "Message");
						return;
					}
				}
				thread = new Thread(new ThreadStart(run_analyze));
				thread.Start();
			}
		}
		void Prrogress_Handler(string url, int length, bool done, int id){
			// ǂݍݓrǁ[̂[̂
		}
		Record [] extractedRecords;
		void run_analyze(){
			// XԂĂāC͂ւ܂킷
			string url = panelSetting.URL;
			string [] fetchThres = panelSetting.getFetchThreads();
			string [] unfetchThres = panelSetting.getUnFetchThreads();
			string [] files = new string[fetchThres.Length + unfetchThres.Length];
			bool [] fetch = new bool[files.Length];
			reporthanders = new ReadHTMLEventHandler[files.Length];
			ReadHTMLEventHandler handler = new ReadHTMLEventHandler(Prrogress_Handler);
			int idx;
			for(idx = 0; idx < fetchThres.Length; idx++){
				files[idx] = fetchThres[idx];
				fetch[idx] = true;
				reporthanders[idx] = handler;
			}
			for(int i = 0; i < unfetchThres.Length; i++, idx++){
				files[idx] = unfetchThres[i];
				fetch[idx] = false;
				reporthanders[idx] = handler;
			}
			int cnt = files.Length;
			//񓯊
  			//fetchHTMLs(url, files, fetch, reporthanders, cnt, true);
			//
			PrintProgressReset();
			fetchHTMLs(url, files, fetch, reporthanders, cnt, false);

			//R[ho
			extractedRecords = extractRecords(files, cnt);
			Array.Sort(extractedRecords, new RecordComparator());

			// R[hXgAbvf[g
			CreateNameList();
			tabResList.UpdateResListTab();
			UpdateChNameListTab();
			DrawGraph();
			PrintProgress(CreateResultString());
		}
		//ʕ񐶐
		string CreateResultString() {
			StringBuilder sb = new StringBuilder("Result... ");
			string [] strs = new string[counts.Length];
			int [] scores = new int[strs.Length];
			for(int i = 0; i < counts.Length; i++){
				string str = getCharaName(i) + " ( " + counts[i] + "pt )    ";
				strs[i] = str;;
				scores[i] = counts[i];
			}
			Array.Sort(scores, strs);
			for(int i = 1, k = counts.Length-1; k >= 0; i++, k--){
				string str = i + ": " + strs[k];
				sb.Append(str);
			}
			
			return sb.ToString();
		}
		//Ot`
		void DrawGraph(){
			PrintProgress("Drawing graph...  ");
			tabGraph.drawGraph();
			PrintProgress("done.\n");
		}
		// OXgAbvf[g
		public void UpdateNameList(){
			PrintProgress("Recounting...  ");
			tabNameListNew.UpdateNameTables();
			MakeCounts();
			PrintProgress("done.\n");

			UpdateNameListTab();
			tabResList.UpdateResListTab();
			UpdateChNameListTab();
			DrawGraph();
			PrintProgress(CreateResultString());
		}
		// OXg^u̍XV
		void UpdateNameListTab(){
			tabNameListNew.UpdateNameListTabControl();
		}
		//L̖OXg̍XV
		void UpdateChNameListTab(){
			panelChNameList.UpdateChNameListTab();
		}
		// OXg쐬
		// currentNames ͂ō쐬Dł͎QƂ̂
		void CreateNameList(){
			// Validator D
			RecordValidator validator = new RecordValidator(this);
			// ͂ɎgOe[u
			Hashtable [] tables = validator.Tables;

			// OXgNA
			currentNames.Clear();
			for(int i = 0; i < extractedRecords.Length; i++){
				Record rec = extractedRecords[i];
				// 
				int ch = validator.validate(rec);
				if(ch<0) continue;       // ȃGg

				//Lւ̊U
				rec.chara = ch;

				// ȌWv
				if(currentNames.Contains(rec.name)){
					currentNames[rec.name] = (int)currentNames[rec.name] + 1;
				} else {
					currentNames[rec.name] = 1;
				}
				if(ch>0){
					tables[ch][rec.name] = currentNames[rec.name];
				}
			}
			statusMark(SaimoeCounterStatus.CurrentNamesGenerated);
			MakeCounts();
			UpdateNameListTab();
		}
		// mask ͈rbg̃rbg}XNƂāC
		// ̃rbgȏNAărbg𗧂Ă
		void statusMark(int mask){
			status &= (mask-1);
			status |= mask;
		}
		// C
		public static void Main(string [] args) {
			// bZ[W[v܂킷
			Application.Run(new SaimoeCounter());
		}
		// roߕ\Zbg
		void PrintProgressReset(){ 
			panelSetting.PrintProgressReset();
		}
		// ro߂\
		void PrintProgress(string str){ 
			panelSetting.PrintProgress(str);
		}
		//  url ƃXԍ(files)w
		// fetch[i] == trueȂHTML_E[h
		// Xԍt@CƂă[Jɕۑ
		// cnt ̓Xԍ̐
		void fetchHTMLs(string url, string [] files, bool [] fetch, ReadHTMLEventHandler [] handlers, int cnt, bool async){
			int fs = 0;
			for(int i = 0; i < cnt; i++){
				if(fetch[i]) fs++;
			}
			HTMLGetter [] gs = new HTMLGetter[fs];
			if(fs > 0) PrintProgress("Fetching threads...   ");
			fs = 0;
			for(int i = 0; i < cnt; i++){
				if(fetch[i]) {
					gs[fs] = new HTMLGetter(i);

					gs[fs].OnReadProgress+= handlers[i];
 					if(async){
						gs[fs].BeginFetchHTML(url + files[i]);//i񓯊j
 					} else {
						PrintProgress(" "+files[i]);
						gs[fs].FetchHTML(url + files[i]);     //ij
					}
					fs++;
				}
			}
			// 擾Xbh̏I҂i񓯊pj
			if(async){
				for(int i = 0; i < gs.Length; i++){
					gs[i].EndFetchHTML();
				}
			}
			if(fs > 0) PrintProgress("  done.\n");
			// t@Cۑ
			if(fs > 0) PrintProgress("Saving into files...  ");
			if(!Directory.Exists(THRE_DIR)){
				Directory.CreateDirectory(THRE_DIR);
			}
			fs = 0;
			for(int i = 0; i < cnt; i++){
				if(fetch[i]) {
					gs[fs].OnReadProgress-= handlers[i];
					PrintProgress(" "+files[i]);
					FileStream os = new FileStream(THRE_DIR+files[i], FileMode.Create);
					os.Write(gs[fs].ret, 0, gs[fs].ret.Length);
					os.Close();
					fs++;
				}
			}
			if(fs > 0) PrintProgress("  done.\n");
		}


		
		// htmlt@CO̔znāC͌ʂ̃R[hzԂD
		// cnt ̓t@C
		Record [] extractRecords(string [] files, int cnt){
			try{
				PrintProgress("Extracting records...  ");
				Record [][] recs = new Record[cnt][];
				int allnum = 0;
				for(int i = 0; i < cnt; i++){
					// t@C烊[h
					PrintProgress(" "+files[i]);
					FileStream fs = new FileStream(THRE_DIR+files[i], FileMode.Open);
					int len = (int)fs.Length;
					byte [] buf = new byte[len];
					fs.Read(buf, 0, len);
					fs.Close();
					// ɕϊ
					string content = Encoding.GetEncoding("euc-jp").GetString(buf, 0, len);
				
					// 
					recs[i] = HTMLAnalyzer.analyze(content, int.Parse(files[i]));
					PrintProgress("("+recs[i].Length + ") ");
					allnum+=recs[i].Length;
				}
				// SЂƂ܂Ƃ߂ɂ
				int off = 0;
				Record [] allrecs = new Record[allnum];
				for(int i = 0; i < cnt; i++){
					Array.Copy(recs[i], 0, allrecs, off, recs[i].Length);
					off+=recs[i].Length;
				}
				PrintProgress("  done. \n");
				return allrecs;
			} catch (Exception e) {
				System.Console.Error.WriteLine("Source : " + e.Source); 
				System.Console.Error.WriteLine("Message : "+ e.Message);
				System.Console.Error.WriteLine("StackTrace : " + e.StackTrace);
			}
			return null;
		}
		// CX^X̃LR{{bNXƓt
		// R[hǂ𔻒肷NX
		// validate Ń}CiXԂ_ȃR[h
		// ̓Lԍ(1, 2, ... s 0)
		public class RecordValidator{
			public DateTime minTime;    //ŏő厞
			public DateTime maxTime;
			SaimoeCounter scounter;
			Hashtable [] tables;
			public Hashtable [] Tables{
				get{return this.tables;}
			}
			public RecordValidator(SaimoeCounter sc){
				scounter = sc;
				DateTime targetDate = scounter.Date;
				int y = targetDate.Year;
				int m = targetDate.Month;
				int d = targetDate.Day;
				minTime = new DateTime(y,m,d,0,0,0,0);    //ŏő
				maxTime = new DateTime(y,m,d,23,0,59,99);

				tables = scounter.getTables();
// 				tables = new Hashtable[scounter.NumButtleChara+1];
// 				for(int i = 1; i < tables.Length; i++){
// 					tables[i] = scounter.nameTables[(int)scounter.charaIndices[scounter.selectedCharas[i]]];
// 				}
// 				tables[0] = null;
			}
			public int validate(Record rec){
				if(rec.date > maxTime || rec.date < minTime) return -1;//t
				if(rec.code.Equals("")) return -1;      // R[hŗƂ
				if(rec.name.Equals("")) return -1;      // [ŗƂ
				if(rec.number > 950) return -1;         //XԂŗƂ

				//Lւ̊U
				for(int i = 1; i < tables.Length; i++){
					if(tables[i].Contains(rec.name)) return i;
				}
				return 0;
			}
		}
		// OXg̃\[gpr
		class NameListItemComparer : IComparer {
			public NameListItemComparer() {
			}
			public int Compare(object x, object y) {
				ListViewItem ix = (ListViewItem)x;
				ListViewItem iy = (ListViewItem)y;

				int col = 0;
				//  (Ch1)____ / (Ch2)____ / (Unknown) 
				int c = String.Compare(ix.SubItems[col].Text, iy.SubItems[col].Text);
				if(c!=0) return c;
				col++;
				//  iE񂹕j
				c = -String.Compare(ix.SubItems[col].Text, iy.SubItems[col].Text);
				if(c!=0) return c;
				col++;
				// O O
				return String.Compare(ix.SubItems[col].Text, iy.SubItems[col].Text);
			}
		}
		
		public int [] Counts {
			get{return this.counts;}
		}
		public Record [] ExtractedRecords {
			get{return this.extractedRecords;}
		}
		public Hashtable CurrentNames {
			get{return this.currentNames;}
		}
	}
	

}
